Subject: Re: [PATCH] KVM: PPC: Book3S PR: Set hflag to indicate that POWER9 supports 1T segments

From: Paul Mackerras <[email-masked]>
Date: Fri, 7 Dec 2018 22:42:12 +1100

On Fri, Dec 07, 2018 at 10:08:20PM +1100, Michael Ellerman wrote:
> Suraj Jitindar Singh <[email-masked]> writes:
> 
> > When booting a kvm-pr guest on a POWER9 machine the following message is
> > observed:
> > "qemu-system-ppc64: KVM does not support 1TiB segments which guest expects"
> >
> > This is because the guest is expecting to be able to use 1T segments
> > however we don't indicate support for it. This is because we don't set
> > the BOOK3S_HFLAG_MULTI_PGSIZE flag in the hflags in kvmppc_set_pvr_pr()
> > on POWER9.
> >
> > POWER9 does indeed have support for 1T segments, so add a case for
> > POWER9 to the switch statement to ensure it is set.
> 
> If this just checked mmu_has_feature(MMU_FTR_1T_SEGMENT) it would have
> been right in this case, and we'd also never have to update it in
> future.
> 
> Any reason not to?

PR KVM can emulate a different processor from the host.  Checking
mmu_has_feature() will tell you about the host, not the CPU being
emulated.

Paul.